import pickle
import time
import tkinter as tk
from tkinter import messagebox

import ecdsa
from constants import font, rsa_key, client_width, client_height, aes_key, aes_salt, fernet_key
import socket
import threading
from helpers import generate_AES_key, generate_Fernet_key, generate_RSA_keys

klijent = None
domacin = socket.gethostname()
port = 8000
f = open("odabir.txt", "r")
odabir = int(f.read())
f.close()

decipher_rsa, cipher_rsa = generate_RSA_keys(rsa_key)

cipher_aes, decipher_aes = generate_AES_key(aes_key, aes_salt)

fernet = generate_Fernet_key(fernet_key)

def ECDSA_autentikacija_servera(client):
    sig = client.recv(2048)
    vk = pickle.loads(client.recv(65536))
    try:
        vk.verify(sig, b"SERVER")
        print("Veza sa serverom uspjesno uspostavljena!")
    except:
        try:
            print("Veza sa serverom nije uspostavljena...")
        except:
            print("Greska...")

    sk = ecdsa.SigningKey.generate(curve=ecdsa.SECP256k1)
    print(sk)
    vk = sk.get_verifying_key()
    sig = sk.sign(b"CLIENT")
    client.send(sig)
    time.sleep(0.2)
    client.send(pickle.dumps(vk))
    time.sleep(0.5)

def dohvati_Klijenta():
    global username, klijent
    if len(username_input.get()) < 1:
        tk.messagebox.showerror(title="Greška!", message="Morate unijeti korisničko ime kako biste prisustvovali razgovoru.")
    else:
        username = username_input.get()
        spoji_Klijenta(username)

def spoji_Klijenta(k):
    global klijent, port, domacin
    try:
        klijent = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        klijent.connect((domacin, port))
        ECDSA_autentikacija_servera(klijent)
        klijent.send(k.encode('utf-8')) 

        username_input.config(state=tk.DISABLED)
        btn_conn.config(state=tk.DISABLED)
        msg_input_area.config(state=tk.NORMAL)
        btn_send_msg.config(state=tk.NORMAL, fg="#dcdee0", background="#092e20")
        threading._start_new_thread(izmjena_Poruka, (klijent, "m"))
    except Exception as e:
        tk.messagebox.showerror(title="Greška!", message="Nije se moguće povezati na domaćina: " + domacin + " na port-u: " + str(port) + " Server je možda nedostupan.")

def izmjena_Poruka(conn, m):

    global odabir
    while True:
        srv = conn.recv(4096)
        decMsg = ""
        if odabir == 1:
            decMsg = decipher_rsa.decrypt(srv).decode('utf-8')
            if not decMsg: 
                tk.messagebox.showerror(title="Upozorenje!", message="Poruka nije poslana sa server-a.")
                break
        elif odabir == 2:
            decMsg = decipher_aes.decrypt(srv).decode('utf-32')
            if not decMsg: 
                tk.messagebox.showerror(title="Upozorenje!", message="Poruka nije poslana sa server-a.")
                break
        elif odabir == 3:
            msg = srv
            decMsg = fernet.decrypt(msg).decode()
            if not decMsg: 
                tk.messagebox.showerror(title="Upozorenje!", message="Poruka nije poslana sa server-a.")
                break

        poruke = text_area.get("1.0", tk.END).strip()
        text_area.config(state=tk.NORMAL)
        if len(poruke) < 1:
            text_area.insert(tk.END, decMsg)
        else:
            text_area.insert(tk.END, "\n\n" + decMsg)

        text_area.config(state=tk.DISABLED)
        text_area.see(tk.END)

    conn.close()
    prozor.destroy()

def get_Unesena_Poruka(msg):
    global odabir
    f = open("odabir.txt", "r")
    odabir = int(f.read())
    f.close()

    msg = msg.replace('\n', '')

    text_area.config(state=tk.NORMAL)
    if len(msg) < 1:
        tk.messagebox.showerror(title="Upozorenje!", message="Niste unijeli poruku.")
        exit
    else:
        text_area.insert(tk.END, "\n\n" + username + "(You) : " + msg, "vlastita_poruka")

        text_area.config(state=tk.DISABLED)

        posalji_Poruku(msg)

        text_area.see(tk.END)
        msg_input_area.delete('1.0', tk.END)

def posalji_Poruku(msg):
    global odabir
    cipher_aes, decipher_aes = generate_AES_key(aes_key, aes_salt)

    poruka = str(msg)
    if odabir == 1:
        encMess = cipher_rsa.encrypt(poruka.encode('utf-8'))
        klijent.send(encMess)
    elif odabir == 2:
        encMess = cipher_aes.encrypt(poruka.encode('utf-32'))
        klijent.send(encMess)
    
    elif odabir == 3:
        encMess = fernet.encrypt(poruka.encode())
        klijent.send(encMess)
    
    if poruka == "izlaz":
        klijent.close()
        prozor.destroy()
    

if __name__ == '__main__':

    prozor = tk.Tk()
    prozor.title("Klijent")
    prozor.geometry(f"{str(client_width)}x{str(client_height)}")
    foto = tk.PhotoImage(file="images\client.png")
    prozor.iconphoto(False, foto)
    prozor.configure(background="#dcdee0")
    username = " "

    okvir_unos_Korisnika = tk.Frame(prozor, background="#dcdee0")
    label_unos_Korisnika = tk.Label(okvir_unos_Korisnika, text = "Unesite korisničko ime:", font=font, background="#dcdee0")
    label_unos_Korisnika.pack(side=tk.LEFT, padx=(10, 10))
    username_input = tk.Entry(okvir_unos_Korisnika, font=font)
    username_input.pack(side=tk.LEFT, padx=(10, 10))
    btn_conn = tk.Button(okvir_unos_Korisnika, text="Unesi", command=lambda : dohvati_Klijenta(), font=font)
    btn_conn.pack(side=tk.RIGHT, padx=(10, 10))
    okvir_unos_Korisnika.pack(side=tk.TOP, pady=(10, 10))

    okvir_prikaz_Poruka = tk.Frame(prozor)
    vert_scroll_bar = tk.Scrollbar(okvir_prikaz_Poruka)
    vert_scroll_bar.pack(side=tk.RIGHT, fill=tk.Y)
    text_area = tk.Text(okvir_prikaz_Poruka, height = client_height - 745, width=client_width - 10, state="disabled", font=font)
    text_area.pack(side=tk.LEFT, fill=tk.Y, pady=(10, 10), padx=(10, 10))
    text_area.tag_config("vlastita_poruka", foreground="#092e20")
    vert_scroll_bar.config(command=text_area.yview)
    text_area.config(yscrollcommand=vert_scroll_bar.set, background="#F4F6F7", state="disabled")
    okvir_prikaz_Poruka.pack(side=tk.TOP)

    okvir_slanje_Poruke = tk.Frame(prozor, background="#dcdee0")
    msg_input_area = tk.Text(okvir_slanje_Poruke, height=2, width=client_width - 1010, state="disabled", font=font)
    msg_input_area.pack(side=tk.LEFT, padx=(5, 10), pady=(5, 10))
    msg_input_area.bind("<Return>", (lambda event: get_Unesena_Poruka(msg_input_area.get("1.0", tk.END))))
    btn_send_msg = tk.Button(okvir_slanje_Poruke, text="➤",  command=lambda : get_Unesena_Poruka(msg_input_area.get("1.0", tk.END)), font=font, state="disabled")
    btn_send_msg.pack(side=tk.RIGHT, pady=(5, 5))
    okvir_slanje_Poruke.pack(side=tk.BOTTOM)

    prozor.mainloop()