import os
import pickle
import time
from Crypto.PublicKey import RSA
from Crypto.Cipher import PKCS1_OAEP, AES
from Crypto.Protocol.KDF import PBKDF2
from cryptography.fernet import Fernet
from ecdsa import VerifyingKey, SigningKey
import ecdsa

def get_Index(lista_klijenata, trenutni_klijent):

    index = 0
    for i in lista_klijenata:
        if i == trenutni_klijent:
            break
        index = index + 1

    return index

def generate_RSA_keys(key):

    if not (os.path.isfile("priv_key.pem") or os.path.isfile("pub_key.pem")):

        priv_key = key.export_key()
        pub_key = key.publickey().export_key()

        priv_key_pem = open('priv_key.pem', 'wb')
        priv_key_pem.write(priv_key)
        priv_key_pem.close()
        pub_key_pem = open('pub_key.pem', 'wb')
        pub_key_pem.write(pub_key)
        pub_key_pem.close()

    pub_key_pem = open('pub_key.pem', 'rb')
    priv_key_pem = open('priv_key.pem', 'rb')
    rsa_priv = RSA.importKey(priv_key_pem.read())
    rsa_pub = RSA.importKey(pub_key_pem.read())

    decipher_rsa = PKCS1_OAEP.new(rsa_priv)
    cipher_rsa = PKCS1_OAEP.new(rsa_pub)

    return decipher_rsa, cipher_rsa

def generate_AES_key(aes_key, aes_salt):
    
    cipher_aes = AES.new(aes_key, AES.MODE_CFB, aes_salt)
    decipher_aes = AES.new(aes_key, AES.MODE_CFB, aes_salt)
    return  cipher_aes, decipher_aes

def generate_Fernet_key(fernet_key):
    if not os.path.isfile("fernet_key.key"):

        with open("fernet_key.key", "wb") as key_file:
            key_file.write(fernet_key)

    with open("fernet_key.key", "rb") as key_file:
        read_key = key_file.read()
    
    fernet = Fernet(read_key)

    return fernet

