import pickle
import time
import tkinter as tk
import socket
import threading as thr

import ecdsa
from constants import font, header_font, rsa_key, aes_key, aes_salt, fernet_key
from helpers import get_Index, generate_AES_key, generate_RSA_keys, generate_Fernet_key

odabir_algoritma = 0
server = None
spojeni_klijent = ""
domacin = socket.gethostname()
port = 8000
klijenti = []
popis_klijenata = []

def ECDSA_autentikacija_klijenta(klijent):
    sk = ecdsa.SigningKey.generate(curve=ecdsa.SECP256k1)
    print(sk)
    vk = sk.get_verifying_key()
    sig = sk.sign(b"SERVER")
    klijent.send(sig)
    time.sleep(0.2)
    klijent.send(pickle.dumps(vk))

    sig = klijent.recv(2048)
    vk = pickle.loads(klijent.recv(65536))

    try: 
        vk.verify(sig, b"CLIENT")
        print("Veza sa klijentom uspjesno uspostavljena!")
    except:
        try:
            print("Veza sa klijentom nije uspostavljena...")
        except:
            print("Greska...")

def odabir_Algoritma():
    global decipher_rsa, cipher_rsa, odabir_algoritma, cipher_aes, decipher_aes, fernet, ecdsa_priv, ecdsa_pub
    if odabir_algoritma == 3:
        odabir_algoritma = 0
    odabir_algoritma = odabir_algoritma + 1
    f = open("odabir.txt", "w")
    f.write(str(odabir_algoritma))
    f.close()
    if odabir_algoritma == 1:
        decipher_rsa, cipher_rsa = generate_RSA_keys(rsa_key)
        btn_change_alg.config(text="RSA")

    elif odabir_algoritma == 2:
        cipher_aes, decipher_aes = generate_AES_key(aes_key, aes_salt)
        btn_change_alg.config(text="AES")

    elif odabir_algoritma == 3:
        fernet = generate_Fernet_key(fernet_key)
        btn_change_alg.config(text="Fernet")

def ostvari_Konekciju():
    global server, domacin, port
    btn_start_conn.config(background="light green", state=tk.DISABLED)
    btn_kill_conn.config(background="#ff6161", state=tk.NORMAL)

    server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    server.bind((domacin, port))
    server.listen(5) 

    thr._start_new_thread(spoji_Klijenta, (server, " "))

    naziv_Host["text"] = "Domaćin: " + domacin
    naziv_Port["text"] = "Port: " + str(port)


def prekini_Konekciju():
    global popis_klijenata
    btn_start_conn.config(background="#ff6161", state=tk.NORMAL)
    btn_kill_conn.config(background="light green", state=tk.DISABLED)

    naziv_Host["text"] = "Domaćin: N.P." 
    naziv_Port["text"] = "Port: N.P." 

    server.close()
    popis_klijenata.clear()

def spoji_Klijenta(srv, nonce):
    while True:
        klijent, adresa = srv.accept()
        ECDSA_autentikacija_klijenta(klijent)
        klijenti.append(klijent)

        thr._start_new_thread(izmjena_Poruka, (klijent, adresa))

def izmjena_Poruka(conn, adr):
    global server, spojeni_klijent, klijenti
    poruka = ""

    spojeni_klijent = conn.recv(4096).decode()
    pozdravni_msg = str(spojeni_klijent + ", nalazite se u grupnom razgovoru!\nZa izlaz iz razgovora unesite 'izlaz'.")

    if odabir_algoritma == 1:
        enc_Pozdravni = cipher_rsa.encrypt(pozdravni_msg.encode('utf-8'))
        print(enc_Pozdravni)
        conn.send(enc_Pozdravni)
    elif odabir_algoritma == 2:
        enc_Pozdravni = cipher_aes.encrypt(pozdravni_msg.encode('utf-32'))
        print(enc_Pozdravni)
        conn.send(enc_Pozdravni)
    elif odabir_algoritma == 3:
        enc_Pozdravni = fernet.encrypt(pozdravni_msg.encode())
        print(enc_Pozdravni)
        conn.send(enc_Pozdravni)
    popis_klijenata.append(spojeni_klijent)

    azuriraj_Popis_Klijenata(popis_klijenata) 

    while True:
        data = conn.recv(4096)
        if odabir_algoritma == 1:
            poruka = data
            decMess = decipher_rsa.decrypt(poruka).decode('utf-8')
            print(decMess)
            if not decMess: 
                break
            if decMess == "izlaz": 
                for k in klijenti:
                    if k != conn:
                        odjavni_msg = str((spojeni_klijent + " izlazi iz grupnog razgovora!"))
                        enc_Odjavni = cipher_rsa.encrypt(odjavni_msg.encode('utf-8'))
                        k.send(enc_Odjavni)
                        break
                break
        elif odabir_algoritma == 2:
            mssg = data
            decMess = decipher_aes.decrypt(mssg).decode('utf-32')
            print(decMess)
            if not decMess: 
                break
            if decMess == "izlaz": 
                for k in klijenti:
                    if k != conn:
                        odjavni_msg = str((spojeni_klijent + " izlazi iz grupnog razgovora!"))
                        enc_Odjavni = cipher_aes.encrypt(odjavni_msg.encode('utf-32'))
                        k.send(enc_Odjavni)
                        break
                break

        elif odabir_algoritma == 3:
            mssg = data
            decMess = fernet.decrypt(mssg).decode()
            print(decMess)
            if not decMess: 
                break
            if decMess == "izlaz": 
                for k in klijenti:
                    if k != conn:
                        odjavni_msg = str((spojeni_klijent + " izlazi iz grupnog razgovora!"))
                        enc_Odjavni = fernet.encrypt(odjavni_msg.encode())
                        k.send(enc_Odjavni)
                        break
                break
        index = get_Index(klijenti, conn)
        poruka_spojenog_klijenta = popis_klijenata[index]
        
        for k in klijenti:
            if k != conn:
                if odabir_algoritma == 1:
                    msg = str(poruka_spojenog_klijenta + " : " + decMess)
                    encMess = cipher_rsa.encrypt(msg.encode('utf-8'))
                    print(encMess)
                    k.send(encMess)
                elif odabir_algoritma == 2:
                    msg = str(poruka_spojenog_klijenta + " : " + decMess)
                    encMess = cipher_aes.encrypt(msg.encode('utf-32'))
                    print(encMess)
                    k.send(encMess)
                elif odabir_algoritma == 3:
                    msg = str(poruka_spojenog_klijenta + " : " + decMess)
                    encMess = fernet.encrypt(msg.encode())
                    print(encMess)
                    k.send(encMess)
                
        
    index = get_Index(klijenti, conn)
    del popis_klijenata[index]
    del klijenti[index]
    conn.close()

    azuriraj_Popis_Klijenata(popis_klijenata) 

def azuriraj_Popis_Klijenata(lista_klijenata):
    text_area.config(state=tk.NORMAL)
    text_area.delete('1.0', tk.END)

    for k in lista_klijenata:
        text_area.insert(tk.END, k +"\n")

if __name__ == '__main__':

    prozor = tk.Tk()
    prozor.title("Server")
    prozor.geometry("480x700")
    foto = tk.PhotoImage(file="images\server.png")
    prozor.iconphoto(False, foto)
    prozor.configure(background="#dcdee0")

    popisKlijenata = tk.Frame(prozor, background="#dcdee0")
    labelPopisKlijenata = tk.Label(popisKlijenata, text="Lista klijenata", background="#dcdee0", font=header_font).pack()
    text_area = tk.Text(popisKlijenata, height=15, width=30, state="disabled", font=font)
    text_area.pack(fill=tk.Y, pady=(5, 5))
    popisKlijenata.pack(side=tk.TOP, pady=(5, 10))

    okvir_Konekcija_i_odabir_Alg = tk.Frame(prozor, background="#dcdee0")
    btn_start_conn = tk.Button(okvir_Konekcija_i_odabir_Alg, text="Pokreni server", command=lambda : ostvari_Konekciju(), font=font)
    btn_start_conn.pack(side=tk.TOP, pady=(5, 5))
    btn_kill_conn = tk.Button(okvir_Konekcija_i_odabir_Alg, text="Zaustavi server", command=lambda : prekini_Konekciju(), state=tk.DISABLED, font=font)
    btn_kill_conn.pack(pady=(5, 5))
    btn_change_alg = tk.Button(okvir_Konekcija_i_odabir_Alg, text="Pokreni enkripciju", command=lambda : odabir_Algoritma(), font=font)
    btn_change_alg.pack(side=tk.BOTTOM, pady=(5, 5))
    okvir_Konekcija_i_odabir_Alg.pack(side=tk.TOP, pady=(5, 0))

    okvir_Host_Port = tk.Frame(prozor, background="#dcdee0")
    naziv_Host = tk.Label(okvir_Host_Port, text = "Domaćin: N.P.", background="#dcdee0", font=font)
    naziv_Host.pack(side=tk.TOP)
    naziv_Port = tk.Label(okvir_Host_Port, text = "Port: N.P.", background="#dcdee0", font=font)
    naziv_Port.pack(side=tk.BOTTOM)
    okvir_Host_Port.pack(side=tk.BOTTOM, pady=(10, 10))

    prozor.mainloop()